﻿// WordCyrToUnicode.jsx

/*
    
Если вы импортируете присланный на вёрстку файл, сделанный в Word, и видите что-то, похожее на такие крокозябры 
 Åùå áîëüøå ìíå íðàâèòñÿ âîçâðàùàòüñÿ äîìîé
 значит, в файле слетела кодировка.
 И восстановить её можно прямо в индизайне после импорта: выделите проблемный текст и запустите этот скрипт.    
 Будет прогрессбар, а после завершения обработки всего файла появится сообщение "Готово".
 
 © Михаил Иванюшин, 2019  |  dotextok.ru  |  dotextok@gmail.com

*/
var programTitul = "Восстановление потерянной кодировки кириллицы";

var ProgressBar = function(title) { // ProgressBar
     var w = new Window('palette', title, {x:0, y:0, width:700, height:40},{closeButton: false}),    
          pb = w.add('progressbar', {x:20, y:12, width:660, height:12});
          w.center();
     this.reset = function(maxValue) {
          pb.value = 0;
          pb.maxvalue = maxValue;
          w.show();
          w.update();          
      };
     this.hit = function(value) {pb.value +=1; w.update();};
     this.close = function() {w.close();};
} // ProgressBar

////
if (app.documents.length == 0) {
    alert("Нет открытых документов.", programTitul);
    exit();
    }
var mySel = app.selection[0];
if (mySel == null || (mySel.constructor.name != "Character" && mySel.constructor.name != "Word" && mySel.constructor.name != "Paragraph" && mySel.constructor.name != "Text" && mySel.constructor.name != "TextColumn" && mySel.constructor.name != "TextStyleRange")) { // == null
    alert("Перед запуском скрипта должен быть выделен текст.", programTitul);
    exit();    
    } // == null
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
var pBar = new ProgressBar(programTitul); 
pBar.reset(67); // 256 - 192 + 1 + 1 + 1 = 67; || последние  +1 +1 -- учёт поиска букв ё и Ё
for (var i = 192; i < 256; i++, pBar.hit()) { // for
    app.findGrepPreferences.findWhat = '\\x{00' + i.toString(16) + '}';  // <<< я видел такое оформление этой операции:  i.toString(16).toUpperCase(), но не обнаружил разницы между i.toString(16) , i.toString(16).toUpperCase() и i.toString(16).toLowerCase().  Поэтому оставил только преобразование в шестнадцатеричную запись, без контроля регистра. Может быть, это '.toUpperCase()' важно для маков, тогда добавьте. Под Windows разницы не замечено.
    app.changeGrepPreferences.changeTo = '\\x{0' + (i + 848).toString(16)  + '}';   // <<<       
    mySel.changeGrep(); 
    } // for
app.findGrepPreferences.findWhat = '\\x{00B8}'; 
app.changeGrepPreferences.changeTo = 'ё'; 
mySel.changeGrep(); 
pBar.hit();
app.findGrepPreferences.findWhat = '\\x{00A8}'; 
app.changeGrepPreferences.changeTo = 'Ё'; 
mySel.changeGrep(); 
pBar.hit();
pBar.close();
app.findGrepPreferences = null; 
app.changeGrepPreferences = null; 
alert("Готово.", programTitul); // эту строку можно и отключить: закомментировать или вообще стереть.
exit();



